#include <sqlextract/tables/tablespace.h>
#include <stdlib.h>

struct tablespace_t {
	struct table_t **tables;
	int tables_size;
};

struct tablespace_t *tablespace_create(void) {
	struct tablespace_t *ts = malloc(sizeof(struct tablespace_t));
	ts->tables = NULL;
	ts->tables_size = 0;
	return ts;
}

void tablespace_destroy(struct tablespace_t *ts) {
	int i;
	for (i = 0; i < ts->tables_size; i++) {
		table_destroy(ts->tables[i]);
	}
	free(ts->tables);
	free(ts);
}

int tablespace_add(struct tablespace_t *ts, struct table_t *tbl, int tablename) {
	int new_size = ts->tables_size;
	int result;
	if (new_size == 0) {
		new_size = 1;
	}
	while (new_size <= tablename) {
		new_size *= 2;
	}
	if (ts->tables_size < new_size) {
		ts->tables = realloc(ts->tables,
				sizeof(struct tables_t *[new_size]));
		while (ts->tables_size < new_size) {
			ts->tables[ts->tables_size++] = NULL;
		}
	}
	result = ts->tables[tablename] != NULL;
	table_destroy(ts->tables[tablename]);
	ts->tables[tablename] = tbl;
	return result;
}

struct table_t *tablespace_get(struct tablespace_t *ts, int tablename) {
	if(tablename >= ts->tables_size)
		return NULL;
	return ts->tables[tablename];
}
